(* $Id: ML_int.ml 1453 2006-07-04 10:50:04Z roglo $ *)

open Printf
open Scanf

let genBinary f a b r =
  for i = 0 to Array.length r - 1 do
    r.(i) <- f a.(i) b.(i)
  done

let int_cst i v r = r.(i-1) <- v
let int_Arit_add _ a b r = genBinary ( + ) a b r
let int_Arit_div _ a b r = genBinary ( / ) a b r
let int_Arit_mod _ a b r = genBinary ( mod ) a b r
let int_Arit_mul _ a b r = genBinary ( * ) a b r

let int_Log_eq a b r = r.(0) <- a.(0) = b.(0)
let int_Log_lt a b r = r.(0) <- a.(0) < b.(0)

let int_input n i r =
  let v =
    let rec loop ntimes =
      printf "%s? " n;
      flush stdout;
      try int_of_string (input_line stdin) with
        Failure _ ->
          if ntimes <= 1 then failwith "Sorry"
          else begin
            printf "integer expected\n";
            loop (ntimes - 1)
          end
    in
    loop 3
  in
  r.(i-1) <- v

let int_output n i r = printf "%s: %d\n" n r.(i-1); flush stdout
